| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::CallStreamEndpointInterface Class Reference

`#include <TelepathyQt/CallStreamEndpoint>`

Inheritance diagram for Tp::Client::CallStreamEndpointInterface:
[legend]

## Public Slots

QDBusPendingReply | SetSelectedCandidatePair (const Tp::Candidate &localCandidate, const Tp::Candidate &remoteCandidate, int timeout=-1)
QDBusPendingReply | SetEndpointState (uint component, uint state, int timeout=-1)
QDBusPendingReply | AcceptSelectedCandidatePair (const Tp::Candidate &localCandidate, const Tp::Candidate &remoteCandidate, int timeout=-1)
QDBusPendingReply | RejectSelectedCandidatePair (const Tp::Candidate &localCandidate, const Tp::Candidate &remoteCandidate, int timeout=-1)
QDBusPendingReply | SetControlling (bool controlling, int timeout=-1)

## Signals

void | RemoteCredentialsSet (const QString &username, const QString &password)
void | RemoteCandidatesAdded (const Tp::CandidateList &candidates)
void | CandidatePairSelected (const Tp::Candidate &localCandidate, const Tp::Candidate &remoteCandidate)
void | EndpointStateChanged (uint component, uint state)
void | ControllingChanged (bool controlling)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| CallStreamEndpointInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| CallStreamEndpointInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| CallStreamEndpointInterface (Tp::DBusProxy *proxy)
Tp::PendingVariant * | requestPropertyRemoteCredentials () const
Tp::PendingVariant * | requestPropertyRemoteCandidates () const
Tp::PendingVariant * | requestPropertySelectedCandidatePairs () const
Tp::PendingVariant * | requestPropertyEndpointState () const
Tp::PendingVariant * | requestPropertyTransport () const
Tp::PendingVariant * | requestPropertyControlling () const
Tp::PendingVariant * | requestPropertyIsICELite () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Call1.Stream.Endpoint".

## Constructor & Destructor Documentation

Tp::Client::CallStreamEndpointInterface::CallStreamEndpointInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallStreamEndpointInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallStreamEndpointInterface::CallStreamEndpointInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallStreamEndpointInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallStreamEndpointInterface::CallStreamEndpointInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a CallStreamEndpointInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static QLatin1String Tp::Client::CallStreamEndpointInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Call1.Stream.Endpoint", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyRemoteCredentials | ( |  | ) | const

inline

Asynchronous getter for the remote object property `RemoteCredentials` of type `Tp::StreamCredentials`.

The ICE credentials used for all candidates. If each candidate has different credentials, then this property SHOULD be ("", ""). Per-candidate credentials are set in the Candidate's Candidate_Info a{sv}.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyRemoteCandidates | ( |  | ) | const

inline

Asynchronous getter for the remote object property `RemoteCandidates` of type `Tp::CandidateList`.

A list of candidates for this endpoint.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertySelectedCandidatePairs | ( |  | ) | const

inline

Asynchronous getter for the remote object property `SelectedCandidatePairs` of type `Tp::CandidatePairList`.

The candidates that have been selected for use to stream packets to the remote contact for each component of the stream. Change notification is given via the the CandidatePairSelected() signal.

Note to client implementors (from RFC 5245 section 9.2.2.3):

> If at least one of the pairs is In-Progress, the agent SHOULD wait for those checks to complete, and as each completes, redo the processing in this section until there are no losing pairs.

Also note that some or all of the local candidates in this list may represent a peer-reflexive candidate that do not appear in CallStreamInterfaceMediaInterface::LocalCandidates .

See RFC 5245 Appendix B.6. for more details about why this is.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyEndpointState | ( |  | ) | const

inline

Asynchronous getter for the remote object property `EndpointState` of type `Tp::ComponentStateMap`.

The state of ICE negotiation with this Endpoint for each component of the stream.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyTransport | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Transport` of type `uint`.

The transport type for the stream endpoint. This can be different from the transport of the Stream in the case where of falling back from ICE to Raw_UDP.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyControlling | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Controlling` of type `bool`.

The local side is taking the controlling role (as defined by ICE RFC 5245). Change notification is given via the ControllingChanged() signal.

In ICE, the Caller is normally in controlling mode (and the Callee in controlled-mode), except if the Caller is doing ICE-Lite, in which case it's reversed. The Controlling side is responsible for selecting nominated pairs, and generating updated offers upon conclusion of ICE.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamEndpointInterface::requestPropertyIsICELite | ( |  | ) | const

inline

Asynchronous getter for the remote object property `IsICELite` of type `bool`.

The Remote side is an ICE Lite endpoint. (The local side is assumed to always be an ICE Full implementation.)

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::CallStreamEndpointInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::CallStreamEndpointInterface::SetSelectedCandidatePair | ( | const Tp::Candidate & | localCandidate,
|  | const Tp::Candidate & | remoteCandidate,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `SetSelectedCandidatePair` on the remote object.

Update the entry in SelectedCandidatePairs for a particular component, and signal it to the remote side.

This method should only be called by the controlling side of an ICE session. See CandidatePairSelected() for details.

In the SDP offer/answer model, this signalling will take place as generating an updated offer. Note that updates may be queued up until information about all components of all streams is gathered.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  localCandidate

      The local candidate that has been selected.

  remoteCandidate

      The remote candidate that has been selected.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamEndpointInterface::SetEndpointState | ( | uint | component,
|  | uint | state,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `SetEndpointState` on the remote object.

Change the EndpointState of the endpoint.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  component

      The component whose state needs updating.

  state

      The new state of this component.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamEndpointInterface::AcceptSelectedCandidatePair | ( | const Tp::Candidate & | localCandidate,
|  | const Tp::Candidate & | remoteCandidate,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `AcceptSelectedCandidatePair` on the remote object.

Called in response to CandidatePairSelected if/when this candidate pair is known to have passed its connectivity checks.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  localCandidate

      The local candidate that has been selected.

  remoteCandidate

      The remote candidate that has been selected.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamEndpointInterface::RejectSelectedCandidatePair | ( | const Tp::Candidate & | localCandidate,
|  | const Tp::Candidate & | remoteCandidate,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `RejectSelectedCandidatePair` on the remote object.

Called in response to CandidatePairSelected if/when this candidate pair is known to have failed its connectivity checks.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  localCandidate

      The local candidate that has been selected.

  remoteCandidate

      The remote candidate that has been selected.

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamEndpointInterface::SetControlling | ( | bool | controlling,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `SetControlling` on the remote object.

Set whether the local side is taking the Controlling role. Note that if there are multiple endpoints (e.g. SIP call forking) it may be the case that all endpoints need to have the same controlling/controlled orientation.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  controlling

      The new value of Controlling.

  timeout | The timeout in milliseconds.

void Tp::Client::CallStreamEndpointInterface::RemoteCredentialsSet | ( | const QString & | username,
|  | const QString & | password
| ) |  |

signal

Represents the signal `RemoteCredentialsSet` on the remote object.

Emitted when the remote ICE credentials for the endpoint are set. If each candidate has different credentials, then this signal will never be fired.

Parameters

  username

      The username set.

  password

      The password set.

void Tp::Client::CallStreamEndpointInterface::RemoteCandidatesAdded | ( | const Tp::CandidateList & | candidates | ) |

signal

Represents the signal `RemoteCandidatesAdded` on the remote object.

Emitted when remote candidates are added to the RemoteCandidates property.

Parameters

  candidates

      The candidates that were added.

void Tp::Client::CallStreamEndpointInterface::CandidatePairSelected | ( | const Tp::Candidate & | localCandidate,
|  | const Tp::Candidate & | remoteCandidate
| ) |  |

signal

Represents the signal `CandidatePairSelected` on the remote object.

Emitted when a candidate is selected for use in the stream by the controlling side of an ICE session. The controlled side should call AcceptSelectedCandidatePair or RejectSelectedCandidatePair when connectivity checks have either succeeded or failed for this candidate pair. See also: SelectedCandidatePairs.

Parameters

  localCandidate

      The local candidate that has been selected.

  remoteCandidate

      The remote candidate that has been selected.

void Tp::Client::CallStreamEndpointInterface::EndpointStateChanged | ( | uint | component,
|  | uint | state
| ) |  |

signal

Represents the signal `EndpointStateChanged` on the remote object.

Emitted when the EndpointState property changes.

Parameters

  component

      The component whose state has changed.

  state

      The new state of this component.

void Tp::Client::CallStreamEndpointInterface::ControllingChanged | ( | bool | controlling | ) |

signal

Represents the signal `ControllingChanged` on the remote object.

The value of Controlling has changed.

Parameters

  controlling

      The new value of Controlling.

void Tp::Client::CallStreamEndpointInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.